JOIN(1)

NAME
join - relational database operator

SYNOPSIS
join [options] [file1] [file2]

DESCRIPTION
Join forms, on the standard output, a join of the two relations specified by the lines of file1 and file2. If either file1 or file2 is `-', the standard input is used.

File1 and file2 must be sorted in increasing current collating sequence on the fields on which they are to be joined, normally the first in each line.

There is one line in the output for each pair of lines in file1 and file2 that have identical join fields. The output line normally consists of the common field, then the rest of the line from file1, then the rest of the line from file2.

Fields are normally separated by blank, tab or newline. In this case, multiple separators count as one, and leading separators are discarded.

These options are recognized:

-an In addition to the normal output, produce a line for each unpairable line in file n, where n is 1 or 2.

-e s
    Replace empty output fields by string s.

-jn m
    Join on the mth field of file n. If n is missing, use the mth field in each file.

-o list
    Each output line comprises the fields specified in list, each element of which has the form n.m, where n is a file number and m is a field number; or 0, which specifies the join field. The list may either consist of multiple arguments, or of a single argument with elements separated by spaces or commas.

-tc Use character c as a separator (tab character). Every appearance of c in a line is significant.

The following options have been introduced by POSIX.2:

-vn Suppress normal output and produce a line for each unpairable line in file n, where n is 1 or 2.

-1 m
    Join on the mth field of file 1.

-2 m
    Join on the mth field of file 2.

ENVIRONMENT VARIABLES

LANG, LC_ALL
    See locale(7).

LC_CTYPE
    Determines the mapping of bytes to characters.

LC_COLLATE
    Specifies the collation sequence.

SEE ALSO
sort(1), comm(1), awk(1), locale(7)

NOTES
With default field separation, the collating sequence is that of sort -b; with -t, the sequence is that of a plain sort.

The conventions of join, sort, comm, uniq and awk(1) are wildly incongruous.